.386
.model flat,stdcall
option casemap:none

extern Resource:byte

include		\masm32\include\windows.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\kernel32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
msg db 'Memory dialog template',0
title1 db 'About',0

IDM_ABOUT	equ 11
IDM_EXIT	equ 12
IDC_ABOUT	equ 110
IDC_EXIT	equ 120
IDC_EDIT	equ 3000

.data?
hMenu		dd ?
menuflag	dd ?

.code
start:
	invoke GetModuleHandle, NULL
	invoke DialogBoxIndirectParam,eax,ADDR Resource,NULL,ADDR DlgProc,NULL
	invoke ExitProcess,eax

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
        .IF uMsg==WM_INITDIALOG
        	invoke LoadIcon,NULL,IDI_APPLICATION	
		invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
                lea eax,[Resource+09Eh]
                invoke LoadMenuIndirect,eax
        	mov hMenu,eax
		invoke SetMenu,hWnd,eax
        
	.ELSEIF uMsg==WM_MOUSEMOVE 
      		mov   eax,lParam        ;XY position of mouse cursor 
      		shr   eax,16            ;keep only the Y position 
      		.IF   eax < 2 && menuflag==0 
         		invoke SetMenu,hWnd,hMenu 
         		mov   menuflag,1 
      		.ELSE 
         		.IF  menuflag == 1 
            			invoke SetMenu,hWnd,0 
            			mov   menuflag,0 
         		.ENDIF 
      		.ENDIF 
	
	.ELSEIF uMsg==WM_CLOSE
                invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

        .ELSEIF uMsg==WM_COMMAND
		
		mov eax,wParam
		.IF lParam==0
                        .IF ax==IDM_ABOUT
                                invoke MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
			.ELSEIF ax==IDM_EXIT
                                @@:
                                invoke EndDialog, hWnd,NULL
			.ENDIF
		.ELSE
			mov edx,wParam
			shr edx,16
			.IF dx==BN_CLICKED
                                
				.IF ax==IDC_ABOUT
                                        invoke SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                        	
				.ELSEIF ax==IDC_EXIT
                                        jmp @b
				.ENDIF
			.ENDIF
		.ENDIF
	.ELSE
		mov eax,FALSE
		ret
	.ENDIF
	mov eax,TRUE
	ret
DlgProc endp
end start
