.386
.model flat,stdcall
option casemap:none

include         \masm32\include\windows.inc
include         \masm32\include\kernel32.inc
include         \masm32\include\user32.inc
include         \masm32\include\masm32.inc
includelib      \masm32\lib\kernel32.lib
includelib      \masm32\lib\user32.lib
includelib      \masm32\lib\masm32.lib

wsprintfA PROTO C :DWORD,:VARARG
wsprintf equ <wsprintfA>

.data
res0 db 0
res1 db 'Cursor',0
res2 db 'Bitmap',0
res3 db 'Icon',0
res4 db 'Menu',0
res5 db 'Dialog',0
res6 db 'String table',0
res7 db 'Font directory',0
res8 db 'Font',0
res9 db 'Accelerators table',0
resA db 'RC Data (custom binary data)',0
resB db 'Message table',0
resC db 'Group cursor',0
resD db 0
resE db 'Group icon',0
resF db 0
res10 db 'Version Information',0
res11 db 'Dialog Include',0
res12 db 0
res13 db 'Plug ',39,'n',39,' Play',0
res14 db 'VXD',0
res15 db 'Animated Cursor',0
res16 db 'Animated Icon',0
restable dd res0,res1,res2,res3,res4,res5,res6,res7,res8
	 dd res9,resA,resB,resC,resD,resE,resF,res10
	 dd res11,res12,res13,res14,res15,res16   

message         db 'Resource to binary file converter V1.0',13,10
                db 'usage : res2bin rsrcfile.res',0
format1         db 'Resource type:%s OFFSET=%X SIZE=%X',13,10,0
format2         db 'Resource type:%s - USER DEFINED   OFFSET=%X SIZE=%X',13,10,0
alignvalue      dd 4
resoffset       dd 0
resheader       dd 0,000000020h,00000FFFFh,00000FFFFh,0,0,0,0
notvalidres     db 'Invalid resource file',0
nofile          db 'Error on reading file',0

.data?
cmdlineparam    db 128 dup(?)
msgbuffer	db 512 dup(?)
msgbuffer2      db 512 dup(?)
buffer          dd ?
temp		dd ?
hRes            dd ?
hBin            dd ?
fSize		dd ?
eof             dd ?
size1           dd ?

.code
start:
        invoke ArgClC,1,ADDR cmdlineparam
        mov al,BYTE PTR [cmdlineparam]
        or al,al
        jnz @f
        invoke StdOut,ADDR message
        jmp finish
        @@:
        invoke CreateFile,ADDR cmdlineparam,GENERIC_READ,\
               0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
        cmp eax,INVALID_HANDLE_VALUE
        jne @f
        invoke StdOut,ADDR nofile
        jmp finish
@@:
        mov hRes,eax
        invoke GetFileSize,eax,0
	mov fSize,eax
	invoke GlobalAlloc,GPTR,eax
	mov buffer,eax 
	invoke ReadFile,hRes,eax,fSize,ADDR temp,0
	invoke CloseHandle,hRes
        mov edx,OFFSET cmdlineparam
@@:
        mov al,[edx]
        cmp al,'.'
        je @f
        inc edx
        jmp @b
        @@:
        inc edx
        mov dword ptr [edx],'nib'
        mov esi,buffer
        mov edi,esi
        add edi,fSize
        mov eof,edi
	mov ecx,8
	mov edx,OFFSET resheader
@@:
	mov eax,DWORD PTR [edx]
        cmp DWORD PTR [esi],eax
	jne invalid
	add esi,4
	add edx,4
	loop @b 
        jmp binfile
invalid:
	invoke StdOut,ADDR notvalidres
	jmp finish
binfile:
        invoke CreateFile,ADDR cmdlineparam,GENERIC_WRITE,\
               0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
        mov hBin,eax
restart:
        mov eax,DWORD PTR [esi+8]
	cmp ax,0FFFFh
        je @f
        invoke WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,\
        eax,-1,ADDR msgbuffer2,512,0,0
        invoke wsprintf,ADDR msgbuffer,ADDR format2,ADDR msgbuffer2,resoffset,DWORD PTR [esi]
        jmp OK

@@:
        shr eax,16
        lea eax,[restable+4*eax]
        invoke wsprintf,ADDR msgbuffer,ADDR format1,DWORD PTR [eax],resoffset,DWORD PTR [esi]
OK:
	invoke StdOut,ADDR msgbuffer
        mov eax,DWORD PTR [esi]
        add resoffset,eax
        mov eax,DWORD PTR [esi+4]
        lea edx,[esi+eax]
        invoke WriteFile,hBin,edx,DWORD PTR [esi],ADDR size1,0
        mov eax,DWORD PTR [esi]
	add eax,DWORD PTR [esi+4]
	add esi,eax
        xor edx,edx
        mov eax,esi
        div [alignvalue]
        or edx,edx
        jz @f
        neg edx
        lea esi,[esi+edx+4]
@@:
        cmp esi,eof
        jb restart
        invoke GlobalFree,buffer
        invoke CloseHandle,hBin
finish:
        invoke ExitProcess,0
END start
